<?php

add_editor_style( plugins_url().'/zebline/zebline-editor-style.css' );

if(file_exists('../wp-content/plugins/zebline/zebline-editor-style-color.css')){
    add_editor_style( plugins_url().'/zebline/zebline-editor-style-color.css' );
}

class zebline_function {
    function __construct() {
      add_action('admin_menu', array($this, 'add_pages'));
    }
    function add_pages() {
      add_menu_page('ZEBLINE','ZEBLINE',  'level_8', 'zebline', array($this,'zebline'), plugins_url().'/zebline/images/zebline_icon.png', 26);
    }
    function zebline($content) {
        if ( isset($_POST['zebline_options'])) {
            check_admin_referer('zebline');
            $opt = $_POST['zebline_options'];
            update_option('zebline_options', $opt);
            $filename = '../wp-content/plugins/zebline/zebline-editor-style-color.css';
            if( empty($opt['color1']) ){
                $color1 = '#ff5957';
            }else{
                $color1 = $opt['color1'];
            }
            if( empty($opt['color2']) ){
                $color2 = '#ffbe3b';
            }else{
                $color2 = $opt['color2'];
            }
            if( empty($opt['color3']) ){
                $color3 = '#fffb3e';
            }else{
                $color3 = $opt['color3'];
            }
            if( empty($opt['add1']) ){
                $add1 = '';
            }else{
                $add1 = $opt['add1'].',';
            }
            if( empty($opt['add2']) ){
                $add2 = '';
            }else{
                $add2 = $opt['add2'].',';
            }
            if( empty($opt['add3']) ){
                $add3 = '';
            }else{
                $add3 = $opt['add3'].',';
            }
            $zebline_color_css = <<<EOM
{$add1}.zebline-color-a{
    background: -webkit-gradient(linear,
    left top, left bottom,
    color-stop(50%, transparent),
    color-stop(50%, {$color1}));
    background: linear-gradient(transparent 50%,
    {$color1} 50%);
}
{$add2}.zebline-color-b{
    background: -webkit-gradient(linear,
    left top, left bottom,
    color-stop(50%, transparent),
    color-stop(50%, {$color2}));
    background: linear-gradient(transparent 50%,
    {$color2} 50%);
}
{$add3}.zebline-color-c{
    background: -webkit-gradient(linear,
    left top, left bottom,
    color-stop(50%, transparent),
    color-stop(50%, {$color3}));
    background: linear-gradient(transparent 50%,
    {$color3} 50%);
}
EOM;
                
            file_put_contents($filename, $zebline_color_css);
            ?>
    <div class="updated fade">
        <p><strong><?php _e('設定を保存しました。'); ?></strong></p>
    </div>
    <?php
        }
        ?>
        <div class="wrap">
            <h2><img style="margin: 2px 8px -18px 0;" src="<?php echo plugins_url(); ?>/zebline/images/zebline_128.png" width="64" height="56" alt="">ZEBLINEの詳細設定</h2>
            <?php 
    $PHP_MIN_VER = "7.0";
    $PHP_NOW_VER = phpversion();
    
    if($PHP_NOW_VER < $PHP_MIN_VER){
        echo '<img style="display:block; margin:0 auto;" src="'.plugins_url().'/zebline/images/alert.png" width="200" height="200" >';
        echo '<h3 style="font-size:36px; line-height:1.7; color:red; text-align:center;">あなたのサーバーのPHPのバージョンでは<br>ZEBLINEが使えません！</h3>';
        echo '<p style="font-size:18px; line-height:1.5; max-width:940px; margin:0 auto;">あなたのサーバーのPHPのバージョンは、'.$PHP_NOW_VER .'です。<br>残念ながらZEBLINEの動作条件を満たしておりません。<br>ZEBLINEHはPHP7.0以降の動作を保証しているため、ZEBLINEを使い方はPHPのバージョンを7.0以上にしてください。</p>';
    }
    else{
    ?>
            <form action="" method="post">
                <?php
                wp_nonce_field('zebline');
                $opt = get_option('zebline_options');
                $show_color1 = isset($opt['color1']) ? $opt['color1']: null;
                $show_color2 = isset($opt['color2']) ? $opt['color2']: null;
                $show_color3 = isset($opt['color3']) ? $opt['color3']: null;
                $show_add1 = isset($opt['add1']) ? $opt['add1']: null;
                $show_add2 = isset($opt['add2']) ? $opt['add2']: null;
                $show_add3 = isset($opt['add3']) ? $opt['add3']: null;
                $show_speed = isset($opt['speed']) ? $opt['speed']: null;
                $show_link = isset($opt['link']) ? $opt['link']: null;
                ?>
                    <table class="form-table" style="max-width:580px;">
                        <tr valign="top">
                            <th scope="row"><label for="inputtext">マーカーのスピード<br>デフォルト:2.5秒<br>（例：1.5）</label></th>
                            <td><input placeholder="2.5" name="zebline_options[speed]" type="text" id="inputtext" value="<?php  echo $show_speed ?>" class="regular-text" />
                            </td>
                        </tr>
                        <tr valign="top">
                            <th scope="row"><label for="inputtext">マーカーリンクの点滅させる</label></th>
                            <td><input type="checkbox" name="zebline_options[link]" value="show_link" <?php if($show_link=='show_link' ){ echo 'checked="checked"'; }else{} ?>>
                            </td>
                        </tr>
                        <tr class="zebline-marker-color-low" valign="top">
                            <th scope="row"><label for="inputtext">マーカーAの色<br>デフォルト：#ff5957<br>（例：#aaa, #009633）</label></th>
                            <td><input placeholder="#F6A43B" name="zebline_options[color1]" type="text" id="inputtext" value="<?php  echo $show_color1 ?>" class="regular-text" />
                                <p style="margin-top:0.5em;">このマーカーを使う時は、<br>class：<label for=""><input style="width:280px; text-align:center;" type="text" id="" onfocus="this.select();" readonly="readonly" class="code" value="zebline-maker zebline-color-a"></label><br>を追加してください。</p>
                            </td>
                            <td id="zebline-palette">
                                <div class="zebline-palette-color red"></div>
                                <div class="zebline-palette-color orange"></div>
                                <div class="zebline-palette-color yellow"></div>
                                <div class="zebline-palette-color lightgreen"></div>
                                <div class="zebline-palette-color green"></div>
                                <div class="zebline-palette-color lightblue"></div>
                                <div class="zebline-palette-color blue"></div>
                            </td>
                        </tr>
                        <tr valign="top">
                            <th scope="row"><label for="inputtext">マーカーAに当てたいタグorクラスorID<br>（例：strong, .bold, #text）</label></th>
                            <td><input placeholder="strong, .bold" name="zebline_options[add1]" type="text" id="inputtext" value="<?php  echo $show_add1 ?>" class="regular-text" />
                            </td>
                        </tr>
                        <tr class="zebline-marker-color-low" valign="top">
                            <th scope="row"><label for="inputtext">マーカーBの色<br>デフォルト：#ffbe3b<br>（例：#aaa, #009633）</label></th>
                            <td><input placeholder="#E4878F" name="zebline_options[color2]" type="text" id="inputtext" value="<?php  echo $show_color2 ?>" class="regular-text" />
                                <p style="margin-top:0.5em;">このマーカーを使う時は、<br>class：<label for=""><input style="width:280px; text-align:center;" type="text" id="" onfocus="this.select();" readonly="readonly" class="code" value="zebline-maker zebline-color-b"></label><br>を追加してください。</p>
                            </td>
                            <td id="zebline-palette">
                                <div class="zebline-palette-color red"></div>
                                <div class="zebline-palette-color orange"></div>
                                <div class="zebline-palette-color yellow"></div>
                                <div class="zebline-palette-color lightgreen"></div>
                                <div class="zebline-palette-color green"></div>
                                <div class="zebline-palette-color lightblue"></div>
                                <div class="zebline-palette-color blue"></div>
                            </td>
                        </tr>
                        <tr valign="top">
                            <th scope="row"><label for="inputtext">マーカーBに当てたいタグorクラスorID<br>（例：strong, .bold, #text）</label></th>
                            <td><input placeholder="strong, .bold" name="zebline_options[add2]" type="text" id="inputtext" value="<?php  echo $show_add2 ?>" class="regular-text" />
                            </td>
                        </tr>
                        <tr class="zebline-marker-color-low" valign="top">
                            <th scope="row"><label for="inputtext">マーカーCの色<br>デフォルト：#fffb3e<br>（例：#aaa, #009633）</label></th>
                            <td><input placeholder="#57BDE9" name="zebline_options[color3]" type="text" id="inputtext" value="<?php  echo $show_color3 ?>" class="regular-text" />
                                <p style="margin-top:0.5em;">このマーカーを使う時は、<br>class：<label for=""><input style="width:280px; text-align:center;" type="text" id="" onfocus="this.select();" readonly="readonly" class="code" value="zebline-maker zebline-color-c"></label><br>を追加してください。</p>
                            </td>
                            <td id="zebline-palette">
                                <div class="zebline-palette-color red"></div>
                                <div class="zebline-palette-color orange"></div>
                                <div class="zebline-palette-color yellow"></div>
                                <div class="zebline-palette-color lightgreen"></div>
                                <div class="zebline-palette-color green"></div>
                                <div class="zebline-palette-color lightblue"></div>
                                <div class="zebline-palette-color blue"></div>
                            </td>
                        </tr>
                        <tr valign="top">
                            <th scope="row"><label for="inputtext">マーカーCに当てたいタグorクラスorID<br>（例：strong, .bold, #text）</label></th>
                            <td><input placeholder="strong, .bold" name="zebline_options[add3]" type="text" id="inputtext" value="<?php  echo $show_add3 ?>" class="regular-text" />
                            </td>
                        </tr>
                    </table>
                    <p class="submit"><input type="submit" name="Submit" class="button-primary" value="変更を保存" /></p>
            </form>
            <?php } ?>

            <!-- /.wrap -->

        </div>
        <?php

    }
}

function zebline_cssjs() {
?>

<style>
    #zebline-palette{ overflow: hidden; width: 300px;} 
    #zebline-palette .zebline-palette-color{ float: left; display: inline-block; width: 30px; height: 30px; cursor: pointer;}
    #zebline-palette .zebline-palette-color:hover{opacity: .6;}
    #zebline-palette .zebline-palette-color.red{background-color: #ff5957;}
    #zebline-palette .zebline-palette-color.orange{background-color: #ffbe3b;}
    #zebline-palette .zebline-palette-color.yellow{background-color: #fffb3e;}
    #zebline-palette .zebline-palette-color.lightgreen{background-color: #96e55d;}
    #zebline-palette .zebline-palette-color.green{background-color: #2db915;}
    #zebline-palette .zebline-palette-color.lightblue{background-color: #39d9e6;}
    #zebline-palette .zebline-palette-color.blue{background-color: #20afff;}
</style>
<script>
    function zeblinePalette(n){
        document.querySelectorAll("#zebline-palette")[n].onclick = function(e) {
          // ここに#buttonをクリックしたら発生させる処理を記述する
            var tagetClassName = e.target.className;
            var changeColor;
            if(tagetClassName.match(/red/)){   
                changeColor = '#ff5957';
            }else if(tagetClassName.match(/orange/)){   
                changeColor = '#ffbe3b';
            }else if(tagetClassName.match(/yellow/)){   
                changeColor = '#fffb3e';
            }else if(tagetClassName.match(/lightgreen/)){   
                changeColor = '#96e55d';
            }else if(tagetClassName.match(/green/)){   
                changeColor = '#2db915';
            }else if(tagetClassName.match(/lightblue/)){   
                changeColor = '#39d9e6';
            }else if(tagetClassName.match(/blue/)){
                changeColor = '#20afff';
            }

//            console.log(changeColor);
            if(changeColor){
                var zeblineMarkerColorLow = document.querySelectorAll('.zebline-marker-color-low #inputtext');
//                console.log(zeblineMarkerColorLow);
                zeblineMarkerColorLow[n].value = changeColor;
           }
        };
    }
    zeblinePalette(0);
    zeblinePalette(1);
    zeblinePalette(2);
</script>
<?php
}
add_action('admin_print_footer_scripts', 'zebline_cssjs');


$zebline_function = new zebline_function;


add_action('wp_head','zebline_function');
function zebline_function(){
    $PHP_MIN_VER = "7.0";
    $PHP_NOW_VER = phpversion();
    
    if($PHP_NOW_VER < $PHP_MIN_VER){
    }
    else{
    $zebline_options = get_option('zebline_options');
?>
            <style>
                <?php
                    if(!$zebline_options['add1']==null) {
                        echo $zebline_options['add1'].',';
                    }
                ?>
                .zebline-color-a {
                    background: linear-gradient(transparent 50%,
                    <?php if(!$zebline_options['color1']==null) {
                        echo $zebline_options['color1'];
                    }
                    else {
                        echo "#ff5957";
                    }
                    ?> 50%);
                }

                <?php
                    if(!$zebline_options['add2']==null) {
                        echo $zebline_options['add2'].',';
                    }
                ?>                
                .zebline-color-b {
                    background: linear-gradient(transparent 50%,
                    <?php if(!$zebline_options['color2']==null) {
                        echo $zebline_options['color2'];
                    }
                    else {
                        echo "#ffbe3b";
                    }
                    ?> 50%);
                }

                <?php
                    if(!$zebline_options['add3']==null) {
                        echo $zebline_options['add3'].',';
                    }
                ?>                
                .zebline-color-c {
                    background: linear-gradient(transparent 50%,
                    <?php if(!$zebline_options['color3']==null) {
                        echo $zebline_options['color3'];
                    }
                    else {
                        echo "#fffb3e";
                    }
                    ?> 50%);
                }
                
                <?php
                    if(!$zebline_options['add1']==null) {
                        echo $zebline_options['add1'].',';
                    }
                ?>
                <?php
                    if(!$zebline_options['add2']==null) {
                        echo $zebline_options['add2'].',';
                    }
                ?>
                <?php
                    if(!$zebline_options['add3']==null) {
                        echo $zebline_options['add3'].',';
                    }
                ?>
                .zebline-maker{
                    transition: <?php if(!$zebline_options['speed']==null) {
                        echo $zebline_options['speed'].'s';
                    }
                    else {
                        echo '2.5s';
                    }
                    ?>;
                }

                <?php if($zebline_options['link']=='show_link') {
                    ?>.zebline-show-a a {
                        -webkit-animation: blink 1.5s ease-in-out infinite alternate;
                        animation: blink 1.5s ease-in-out infinite alternate
                    }
                    <?php
                }

                ?>
                <?php
                    if(!$zebline_options['add1']==null) {
                        echo $zebline_options['add1'].',';
                    }
                ?>
                <?php
                    if(!$zebline_options['add2']==null) {
                        echo $zebline_options['add2'].',';
                    }
                ?>
                <?php
                    if(!$zebline_options['add3']==null) {
                        echo $zebline_options['add3'].',';
                    }
                ?>                
                .zebline-maker {
                    font-weight: 700;
                    background-repeat: no-repeat;
                    background-size: 200% 100%;
                    background-position: 200% 0
                }

                .zebline-show {
                    background-position: 100% 0
                }

                @-webkit-keyframes blink {
                    0% {
                        opacity: .1
                    }
                    100% {
                        opacity: 1
                    }
                }

                @keyframes blink {
                    0% {
                        opacity: .1
                    }
                    100% {
                        opacity: 1
                    }
                }

            </style>
            <?php
    }
}

add_action('wp_print_footer_scripts','zebline_function_js');
function zebline_function_js(){ ?>

                    <script>
                    (function($) {
                        $(window).scroll(function() {
                            $("<?php $zebline_options = get_option('zebline_options');
                    if(!$zebline_options['add1']==null) {
                        echo $zebline_options['add1'].',';
                    } 
                    if(!$zebline_options['add2']==null) {
                        echo $zebline_options['add2'].',';
                    } 
                    if(!$zebline_options['add3']==null) {
                        echo $zebline_options['add3'].',';
                    } 
                    ?>.zebline-maker").each(function() {
                                var i = $(this).offset().top;
                                $(window).scrollTop() > i - $(window).height() + 150 && ($(this).addClass("zebline-show"), $(this).delay(2600).queue(function() {
                                    $(this).addClass("zebline-show-a").dequeue()
                                }))
                            });
                        });
                    })(jQuery);
                </script>
                <?php
}
